/**
 * Autogenerated by Thrift Compiler (0.13.0)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package org.eclipse.hawk.service.api;

@SuppressWarnings({"cast", "rawtypes", "serial", "unchecked", "unused"})
@javax.annotation.Generated(value = "Autogenerated by Thrift Compiler (0.13.0)", date = "2021-04-18")
public class DerivedAttributeSpec implements org.apache.thrift.TBase<DerivedAttributeSpec, DerivedAttributeSpec._Fields>, java.io.Serializable, Cloneable, Comparable<DerivedAttributeSpec> {
  private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("DerivedAttributeSpec");

  private static final org.apache.thrift.protocol.TField METAMODEL_URI_FIELD_DESC = new org.apache.thrift.protocol.TField("metamodelUri", org.apache.thrift.protocol.TType.STRING, (short)1);
  private static final org.apache.thrift.protocol.TField TYPE_NAME_FIELD_DESC = new org.apache.thrift.protocol.TField("typeName", org.apache.thrift.protocol.TType.STRING, (short)2);
  private static final org.apache.thrift.protocol.TField ATTRIBUTE_NAME_FIELD_DESC = new org.apache.thrift.protocol.TField("attributeName", org.apache.thrift.protocol.TType.STRING, (short)3);
  private static final org.apache.thrift.protocol.TField ATTRIBUTE_TYPE_FIELD_DESC = new org.apache.thrift.protocol.TField("attributeType", org.apache.thrift.protocol.TType.STRING, (short)4);
  private static final org.apache.thrift.protocol.TField IS_MANY_FIELD_DESC = new org.apache.thrift.protocol.TField("isMany", org.apache.thrift.protocol.TType.BOOL, (short)5);
  private static final org.apache.thrift.protocol.TField IS_ORDERED_FIELD_DESC = new org.apache.thrift.protocol.TField("isOrdered", org.apache.thrift.protocol.TType.BOOL, (short)6);
  private static final org.apache.thrift.protocol.TField IS_UNIQUE_FIELD_DESC = new org.apache.thrift.protocol.TField("isUnique", org.apache.thrift.protocol.TType.BOOL, (short)7);
  private static final org.apache.thrift.protocol.TField DERIVATION_LANGUAGE_FIELD_DESC = new org.apache.thrift.protocol.TField("derivationLanguage", org.apache.thrift.protocol.TType.STRING, (short)8);
  private static final org.apache.thrift.protocol.TField DERIVATION_LOGIC_FIELD_DESC = new org.apache.thrift.protocol.TField("derivationLogic", org.apache.thrift.protocol.TType.STRING, (short)9);

  private static final org.apache.thrift.scheme.SchemeFactory STANDARD_SCHEME_FACTORY = new DerivedAttributeSpecStandardSchemeFactory();
  private static final org.apache.thrift.scheme.SchemeFactory TUPLE_SCHEME_FACTORY = new DerivedAttributeSpecTupleSchemeFactory();

  public @org.apache.thrift.annotation.Nullable java.lang.String metamodelUri; // required
  public @org.apache.thrift.annotation.Nullable java.lang.String typeName; // required
  public @org.apache.thrift.annotation.Nullable java.lang.String attributeName; // required
  public @org.apache.thrift.annotation.Nullable java.lang.String attributeType; // optional
  public boolean isMany; // optional
  public boolean isOrdered; // optional
  public boolean isUnique; // optional
  public @org.apache.thrift.annotation.Nullable java.lang.String derivationLanguage; // optional
  public @org.apache.thrift.annotation.Nullable java.lang.String derivationLogic; // optional

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements org.apache.thrift.TFieldIdEnum {
    METAMODEL_URI((short)1, "metamodelUri"),
    TYPE_NAME((short)2, "typeName"),
    ATTRIBUTE_NAME((short)3, "attributeName"),
    ATTRIBUTE_TYPE((short)4, "attributeType"),
    IS_MANY((short)5, "isMany"),
    IS_ORDERED((short)6, "isOrdered"),
    IS_UNIQUE((short)7, "isUnique"),
    DERIVATION_LANGUAGE((short)8, "derivationLanguage"),
    DERIVATION_LOGIC((short)9, "derivationLogic");

    private static final java.util.Map<java.lang.String, _Fields> byName = new java.util.HashMap<java.lang.String, _Fields>();

    static {
      for (_Fields field : java.util.EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    @org.apache.thrift.annotation.Nullable
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // METAMODEL_URI
          return METAMODEL_URI;
        case 2: // TYPE_NAME
          return TYPE_NAME;
        case 3: // ATTRIBUTE_NAME
          return ATTRIBUTE_NAME;
        case 4: // ATTRIBUTE_TYPE
          return ATTRIBUTE_TYPE;
        case 5: // IS_MANY
          return IS_MANY;
        case 6: // IS_ORDERED
          return IS_ORDERED;
        case 7: // IS_UNIQUE
          return IS_UNIQUE;
        case 8: // DERIVATION_LANGUAGE
          return DERIVATION_LANGUAGE;
        case 9: // DERIVATION_LOGIC
          return DERIVATION_LOGIC;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new java.lang.IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    @org.apache.thrift.annotation.Nullable
    public static _Fields findByName(java.lang.String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final java.lang.String _fieldName;

    _Fields(short thriftId, java.lang.String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public java.lang.String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final int __ISMANY_ISSET_ID = 0;
  private static final int __ISORDERED_ISSET_ID = 1;
  private static final int __ISUNIQUE_ISSET_ID = 2;
  private byte __isset_bitfield = 0;
  private static final _Fields optionals[] = {_Fields.ATTRIBUTE_TYPE,_Fields.IS_MANY,_Fields.IS_ORDERED,_Fields.IS_UNIQUE,_Fields.DERIVATION_LANGUAGE,_Fields.DERIVATION_LOGIC};
  public static final java.util.Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
  static {
    java.util.Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new java.util.EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.METAMODEL_URI, new org.apache.thrift.meta_data.FieldMetaData("metamodelUri", org.apache.thrift.TFieldRequirementType.REQUIRED, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    tmpMap.put(_Fields.TYPE_NAME, new org.apache.thrift.meta_data.FieldMetaData("typeName", org.apache.thrift.TFieldRequirementType.REQUIRED, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    tmpMap.put(_Fields.ATTRIBUTE_NAME, new org.apache.thrift.meta_data.FieldMetaData("attributeName", org.apache.thrift.TFieldRequirementType.REQUIRED, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    tmpMap.put(_Fields.ATTRIBUTE_TYPE, new org.apache.thrift.meta_data.FieldMetaData("attributeType", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    tmpMap.put(_Fields.IS_MANY, new org.apache.thrift.meta_data.FieldMetaData("isMany", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.BOOL)));
    tmpMap.put(_Fields.IS_ORDERED, new org.apache.thrift.meta_data.FieldMetaData("isOrdered", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.BOOL)));
    tmpMap.put(_Fields.IS_UNIQUE, new org.apache.thrift.meta_data.FieldMetaData("isUnique", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.BOOL)));
    tmpMap.put(_Fields.DERIVATION_LANGUAGE, new org.apache.thrift.meta_data.FieldMetaData("derivationLanguage", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    tmpMap.put(_Fields.DERIVATION_LOGIC, new org.apache.thrift.meta_data.FieldMetaData("derivationLogic", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    metaDataMap = java.util.Collections.unmodifiableMap(tmpMap);
    org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(DerivedAttributeSpec.class, metaDataMap);
  }

  public DerivedAttributeSpec() {
  }

  public DerivedAttributeSpec(
    java.lang.String metamodelUri,
    java.lang.String typeName,
    java.lang.String attributeName)
  {
    this();
    this.metamodelUri = metamodelUri;
    this.typeName = typeName;
    this.attributeName = attributeName;
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public DerivedAttributeSpec(DerivedAttributeSpec other) {
    __isset_bitfield = other.__isset_bitfield;
    if (other.isSetMetamodelUri()) {
      this.metamodelUri = other.metamodelUri;
    }
    if (other.isSetTypeName()) {
      this.typeName = other.typeName;
    }
    if (other.isSetAttributeName()) {
      this.attributeName = other.attributeName;
    }
    if (other.isSetAttributeType()) {
      this.attributeType = other.attributeType;
    }
    this.isMany = other.isMany;
    this.isOrdered = other.isOrdered;
    this.isUnique = other.isUnique;
    if (other.isSetDerivationLanguage()) {
      this.derivationLanguage = other.derivationLanguage;
    }
    if (other.isSetDerivationLogic()) {
      this.derivationLogic = other.derivationLogic;
    }
  }

  public DerivedAttributeSpec deepCopy() {
    return new DerivedAttributeSpec(this);
  }

  @Override
  public void clear() {
    this.metamodelUri = null;
    this.typeName = null;
    this.attributeName = null;
    this.attributeType = null;
    setIsManyIsSet(false);
    this.isMany = false;
    setIsOrderedIsSet(false);
    this.isOrdered = false;
    setIsUniqueIsSet(false);
    this.isUnique = false;
    this.derivationLanguage = null;
    this.derivationLogic = null;
  }

  @org.apache.thrift.annotation.Nullable
  public java.lang.String getMetamodelUri() {
    return this.metamodelUri;
  }

  public DerivedAttributeSpec setMetamodelUri(@org.apache.thrift.annotation.Nullable java.lang.String metamodelUri) {
    this.metamodelUri = metamodelUri;
    return this;
  }

  public void unsetMetamodelUri() {
    this.metamodelUri = null;
  }

  /** Returns true if field metamodelUri is set (has been assigned a value) and false otherwise */
  public boolean isSetMetamodelUri() {
    return this.metamodelUri != null;
  }

  public void setMetamodelUriIsSet(boolean value) {
    if (!value) {
      this.metamodelUri = null;
    }
  }

  @org.apache.thrift.annotation.Nullable
  public java.lang.String getTypeName() {
    return this.typeName;
  }

  public DerivedAttributeSpec setTypeName(@org.apache.thrift.annotation.Nullable java.lang.String typeName) {
    this.typeName = typeName;
    return this;
  }

  public void unsetTypeName() {
    this.typeName = null;
  }

  /** Returns true if field typeName is set (has been assigned a value) and false otherwise */
  public boolean isSetTypeName() {
    return this.typeName != null;
  }

  public void setTypeNameIsSet(boolean value) {
    if (!value) {
      this.typeName = null;
    }
  }

  @org.apache.thrift.annotation.Nullable
  public java.lang.String getAttributeName() {
    return this.attributeName;
  }

  public DerivedAttributeSpec setAttributeName(@org.apache.thrift.annotation.Nullable java.lang.String attributeName) {
    this.attributeName = attributeName;
    return this;
  }

  public void unsetAttributeName() {
    this.attributeName = null;
  }

  /** Returns true if field attributeName is set (has been assigned a value) and false otherwise */
  public boolean isSetAttributeName() {
    return this.attributeName != null;
  }

  public void setAttributeNameIsSet(boolean value) {
    if (!value) {
      this.attributeName = null;
    }
  }

  @org.apache.thrift.annotation.Nullable
  public java.lang.String getAttributeType() {
    return this.attributeType;
  }

  public DerivedAttributeSpec setAttributeType(@org.apache.thrift.annotation.Nullable java.lang.String attributeType) {
    this.attributeType = attributeType;
    return this;
  }

  public void unsetAttributeType() {
    this.attributeType = null;
  }

  /** Returns true if field attributeType is set (has been assigned a value) and false otherwise */
  public boolean isSetAttributeType() {
    return this.attributeType != null;
  }

  public void setAttributeTypeIsSet(boolean value) {
    if (!value) {
      this.attributeType = null;
    }
  }

  public boolean isIsMany() {
    return this.isMany;
  }

  public DerivedAttributeSpec setIsMany(boolean isMany) {
    this.isMany = isMany;
    setIsManyIsSet(true);
    return this;
  }

  public void unsetIsMany() {
    __isset_bitfield = org.apache.thrift.EncodingUtils.clearBit(__isset_bitfield, __ISMANY_ISSET_ID);
  }

  /** Returns true if field isMany is set (has been assigned a value) and false otherwise */
  public boolean isSetIsMany() {
    return org.apache.thrift.EncodingUtils.testBit(__isset_bitfield, __ISMANY_ISSET_ID);
  }

  public void setIsManyIsSet(boolean value) {
    __isset_bitfield = org.apache.thrift.EncodingUtils.setBit(__isset_bitfield, __ISMANY_ISSET_ID, value);
  }

  public boolean isIsOrdered() {
    return this.isOrdered;
  }

  public DerivedAttributeSpec setIsOrdered(boolean isOrdered) {
    this.isOrdered = isOrdered;
    setIsOrderedIsSet(true);
    return this;
  }

  public void unsetIsOrdered() {
    __isset_bitfield = org.apache.thrift.EncodingUtils.clearBit(__isset_bitfield, __ISORDERED_ISSET_ID);
  }

  /** Returns true if field isOrdered is set (has been assigned a value) and false otherwise */
  public boolean isSetIsOrdered() {
    return org.apache.thrift.EncodingUtils.testBit(__isset_bitfield, __ISORDERED_ISSET_ID);
  }

  public void setIsOrderedIsSet(boolean value) {
    __isset_bitfield = org.apache.thrift.EncodingUtils.setBit(__isset_bitfield, __ISORDERED_ISSET_ID, value);
  }

  public boolean isIsUnique() {
    return this.isUnique;
  }

  public DerivedAttributeSpec setIsUnique(boolean isUnique) {
    this.isUnique = isUnique;
    setIsUniqueIsSet(true);
    return this;
  }

  public void unsetIsUnique() {
    __isset_bitfield = org.apache.thrift.EncodingUtils.clearBit(__isset_bitfield, __ISUNIQUE_ISSET_ID);
  }

  /** Returns true if field isUnique is set (has been assigned a value) and false otherwise */
  public boolean isSetIsUnique() {
    return org.apache.thrift.EncodingUtils.testBit(__isset_bitfield, __ISUNIQUE_ISSET_ID);
  }

  public void setIsUniqueIsSet(boolean value) {
    __isset_bitfield = org.apache.thrift.EncodingUtils.setBit(__isset_bitfield, __ISUNIQUE_ISSET_ID, value);
  }

  @org.apache.thrift.annotation.Nullable
  public java.lang.String getDerivationLanguage() {
    return this.derivationLanguage;
  }

  public DerivedAttributeSpec setDerivationLanguage(@org.apache.thrift.annotation.Nullable java.lang.String derivationLanguage) {
    this.derivationLanguage = derivationLanguage;
    return this;
  }

  public void unsetDerivationLanguage() {
    this.derivationLanguage = null;
  }

  /** Returns true if field derivationLanguage is set (has been assigned a value) and false otherwise */
  public boolean isSetDerivationLanguage() {
    return this.derivationLanguage != null;
  }

  public void setDerivationLanguageIsSet(boolean value) {
    if (!value) {
      this.derivationLanguage = null;
    }
  }

  @org.apache.thrift.annotation.Nullable
  public java.lang.String getDerivationLogic() {
    return this.derivationLogic;
  }

  public DerivedAttributeSpec setDerivationLogic(@org.apache.thrift.annotation.Nullable java.lang.String derivationLogic) {
    this.derivationLogic = derivationLogic;
    return this;
  }

  public void unsetDerivationLogic() {
    this.derivationLogic = null;
  }

  /** Returns true if field derivationLogic is set (has been assigned a value) and false otherwise */
  public boolean isSetDerivationLogic() {
    return this.derivationLogic != null;
  }

  public void setDerivationLogicIsSet(boolean value) {
    if (!value) {
      this.derivationLogic = null;
    }
  }

  public void setFieldValue(_Fields field, @org.apache.thrift.annotation.Nullable java.lang.Object value) {
    switch (field) {
    case METAMODEL_URI:
      if (value == null) {
        unsetMetamodelUri();
      } else {
        setMetamodelUri((java.lang.String)value);
      }
      break;

    case TYPE_NAME:
      if (value == null) {
        unsetTypeName();
      } else {
        setTypeName((java.lang.String)value);
      }
      break;

    case ATTRIBUTE_NAME:
      if (value == null) {
        unsetAttributeName();
      } else {
        setAttributeName((java.lang.String)value);
      }
      break;

    case ATTRIBUTE_TYPE:
      if (value == null) {
        unsetAttributeType();
      } else {
        setAttributeType((java.lang.String)value);
      }
      break;

    case IS_MANY:
      if (value == null) {
        unsetIsMany();
      } else {
        setIsMany((java.lang.Boolean)value);
      }
      break;

    case IS_ORDERED:
      if (value == null) {
        unsetIsOrdered();
      } else {
        setIsOrdered((java.lang.Boolean)value);
      }
      break;

    case IS_UNIQUE:
      if (value == null) {
        unsetIsUnique();
      } else {
        setIsUnique((java.lang.Boolean)value);
      }
      break;

    case DERIVATION_LANGUAGE:
      if (value == null) {
        unsetDerivationLanguage();
      } else {
        setDerivationLanguage((java.lang.String)value);
      }
      break;

    case DERIVATION_LOGIC:
      if (value == null) {
        unsetDerivationLogic();
      } else {
        setDerivationLogic((java.lang.String)value);
      }
      break;

    }
  }

  @org.apache.thrift.annotation.Nullable
  public java.lang.Object getFieldValue(_Fields field) {
    switch (field) {
    case METAMODEL_URI:
      return getMetamodelUri();

    case TYPE_NAME:
      return getTypeName();

    case ATTRIBUTE_NAME:
      return getAttributeName();

    case ATTRIBUTE_TYPE:
      return getAttributeType();

    case IS_MANY:
      return isIsMany();

    case IS_ORDERED:
      return isIsOrdered();

    case IS_UNIQUE:
      return isIsUnique();

    case DERIVATION_LANGUAGE:
      return getDerivationLanguage();

    case DERIVATION_LOGIC:
      return getDerivationLogic();

    }
    throw new java.lang.IllegalStateException();
  }

  /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    if (field == null) {
      throw new java.lang.IllegalArgumentException();
    }

    switch (field) {
    case METAMODEL_URI:
      return isSetMetamodelUri();
    case TYPE_NAME:
      return isSetTypeName();
    case ATTRIBUTE_NAME:
      return isSetAttributeName();
    case ATTRIBUTE_TYPE:
      return isSetAttributeType();
    case IS_MANY:
      return isSetIsMany();
    case IS_ORDERED:
      return isSetIsOrdered();
    case IS_UNIQUE:
      return isSetIsUnique();
    case DERIVATION_LANGUAGE:
      return isSetDerivationLanguage();
    case DERIVATION_LOGIC:
      return isSetDerivationLogic();
    }
    throw new java.lang.IllegalStateException();
  }

  @Override
  public boolean equals(java.lang.Object that) {
    if (that == null)
      return false;
    if (that instanceof DerivedAttributeSpec)
      return this.equals((DerivedAttributeSpec)that);
    return false;
  }

  public boolean equals(DerivedAttributeSpec that) {
    if (that == null)
      return false;
    if (this == that)
      return true;

    boolean this_present_metamodelUri = true && this.isSetMetamodelUri();
    boolean that_present_metamodelUri = true && that.isSetMetamodelUri();
    if (this_present_metamodelUri || that_present_metamodelUri) {
      if (!(this_present_metamodelUri && that_present_metamodelUri))
        return false;
      if (!this.metamodelUri.equals(that.metamodelUri))
        return false;
    }

    boolean this_present_typeName = true && this.isSetTypeName();
    boolean that_present_typeName = true && that.isSetTypeName();
    if (this_present_typeName || that_present_typeName) {
      if (!(this_present_typeName && that_present_typeName))
        return false;
      if (!this.typeName.equals(that.typeName))
        return false;
    }

    boolean this_present_attributeName = true && this.isSetAttributeName();
    boolean that_present_attributeName = true && that.isSetAttributeName();
    if (this_present_attributeName || that_present_attributeName) {
      if (!(this_present_attributeName && that_present_attributeName))
        return false;
      if (!this.attributeName.equals(that.attributeName))
        return false;
    }

    boolean this_present_attributeType = true && this.isSetAttributeType();
    boolean that_present_attributeType = true && that.isSetAttributeType();
    if (this_present_attributeType || that_present_attributeType) {
      if (!(this_present_attributeType && that_present_attributeType))
        return false;
      if (!this.attributeType.equals(that.attributeType))
        return false;
    }

    boolean this_present_isMany = true && this.isSetIsMany();
    boolean that_present_isMany = true && that.isSetIsMany();
    if (this_present_isMany || that_present_isMany) {
      if (!(this_present_isMany && that_present_isMany))
        return false;
      if (this.isMany != that.isMany)
        return false;
    }

    boolean this_present_isOrdered = true && this.isSetIsOrdered();
    boolean that_present_isOrdered = true && that.isSetIsOrdered();
    if (this_present_isOrdered || that_present_isOrdered) {
      if (!(this_present_isOrdered && that_present_isOrdered))
        return false;
      if (this.isOrdered != that.isOrdered)
        return false;
    }

    boolean this_present_isUnique = true && this.isSetIsUnique();
    boolean that_present_isUnique = true && that.isSetIsUnique();
    if (this_present_isUnique || that_present_isUnique) {
      if (!(this_present_isUnique && that_present_isUnique))
        return false;
      if (this.isUnique != that.isUnique)
        return false;
    }

    boolean this_present_derivationLanguage = true && this.isSetDerivationLanguage();
    boolean that_present_derivationLanguage = true && that.isSetDerivationLanguage();
    if (this_present_derivationLanguage || that_present_derivationLanguage) {
      if (!(this_present_derivationLanguage && that_present_derivationLanguage))
        return false;
      if (!this.derivationLanguage.equals(that.derivationLanguage))
        return false;
    }

    boolean this_present_derivationLogic = true && this.isSetDerivationLogic();
    boolean that_present_derivationLogic = true && that.isSetDerivationLogic();
    if (this_present_derivationLogic || that_present_derivationLogic) {
      if (!(this_present_derivationLogic && that_present_derivationLogic))
        return false;
      if (!this.derivationLogic.equals(that.derivationLogic))
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    int hashCode = 1;

    hashCode = hashCode * 8191 + ((isSetMetamodelUri()) ? 131071 : 524287);
    if (isSetMetamodelUri())
      hashCode = hashCode * 8191 + metamodelUri.hashCode();

    hashCode = hashCode * 8191 + ((isSetTypeName()) ? 131071 : 524287);
    if (isSetTypeName())
      hashCode = hashCode * 8191 + typeName.hashCode();

    hashCode = hashCode * 8191 + ((isSetAttributeName()) ? 131071 : 524287);
    if (isSetAttributeName())
      hashCode = hashCode * 8191 + attributeName.hashCode();

    hashCode = hashCode * 8191 + ((isSetAttributeType()) ? 131071 : 524287);
    if (isSetAttributeType())
      hashCode = hashCode * 8191 + attributeType.hashCode();

    hashCode = hashCode * 8191 + ((isSetIsMany()) ? 131071 : 524287);
    if (isSetIsMany())
      hashCode = hashCode * 8191 + ((isMany) ? 131071 : 524287);

    hashCode = hashCode * 8191 + ((isSetIsOrdered()) ? 131071 : 524287);
    if (isSetIsOrdered())
      hashCode = hashCode * 8191 + ((isOrdered) ? 131071 : 524287);

    hashCode = hashCode * 8191 + ((isSetIsUnique()) ? 131071 : 524287);
    if (isSetIsUnique())
      hashCode = hashCode * 8191 + ((isUnique) ? 131071 : 524287);

    hashCode = hashCode * 8191 + ((isSetDerivationLanguage()) ? 131071 : 524287);
    if (isSetDerivationLanguage())
      hashCode = hashCode * 8191 + derivationLanguage.hashCode();

    hashCode = hashCode * 8191 + ((isSetDerivationLogic()) ? 131071 : 524287);
    if (isSetDerivationLogic())
      hashCode = hashCode * 8191 + derivationLogic.hashCode();

    return hashCode;
  }

  @Override
  public int compareTo(DerivedAttributeSpec other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;

    lastComparison = java.lang.Boolean.valueOf(isSetMetamodelUri()).compareTo(other.isSetMetamodelUri());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetMetamodelUri()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.metamodelUri, other.metamodelUri);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = java.lang.Boolean.valueOf(isSetTypeName()).compareTo(other.isSetTypeName());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetTypeName()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.typeName, other.typeName);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = java.lang.Boolean.valueOf(isSetAttributeName()).compareTo(other.isSetAttributeName());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetAttributeName()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.attributeName, other.attributeName);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = java.lang.Boolean.valueOf(isSetAttributeType()).compareTo(other.isSetAttributeType());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetAttributeType()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.attributeType, other.attributeType);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = java.lang.Boolean.valueOf(isSetIsMany()).compareTo(other.isSetIsMany());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetIsMany()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.isMany, other.isMany);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = java.lang.Boolean.valueOf(isSetIsOrdered()).compareTo(other.isSetIsOrdered());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetIsOrdered()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.isOrdered, other.isOrdered);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = java.lang.Boolean.valueOf(isSetIsUnique()).compareTo(other.isSetIsUnique());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetIsUnique()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.isUnique, other.isUnique);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = java.lang.Boolean.valueOf(isSetDerivationLanguage()).compareTo(other.isSetDerivationLanguage());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetDerivationLanguage()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.derivationLanguage, other.derivationLanguage);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = java.lang.Boolean.valueOf(isSetDerivationLogic()).compareTo(other.isSetDerivationLogic());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetDerivationLogic()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.derivationLogic, other.derivationLogic);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  @org.apache.thrift.annotation.Nullable
  public _Fields fieldForId(int fieldId) {
    return _Fields.findByThriftId(fieldId);
  }

  public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
    scheme(iprot).read(iprot, this);
  }

  public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
    scheme(oprot).write(oprot, this);
  }

  @Override
  public java.lang.String toString() {
    java.lang.StringBuilder sb = new java.lang.StringBuilder("DerivedAttributeSpec(");
    boolean first = true;

    sb.append("metamodelUri:");
    if (this.metamodelUri == null) {
      sb.append("null");
    } else {
      sb.append(this.metamodelUri);
    }
    first = false;
    if (!first) sb.append(", ");
    sb.append("typeName:");
    if (this.typeName == null) {
      sb.append("null");
    } else {
      sb.append(this.typeName);
    }
    first = false;
    if (!first) sb.append(", ");
    sb.append("attributeName:");
    if (this.attributeName == null) {
      sb.append("null");
    } else {
      sb.append(this.attributeName);
    }
    first = false;
    if (isSetAttributeType()) {
      if (!first) sb.append(", ");
      sb.append("attributeType:");
      if (this.attributeType == null) {
        sb.append("null");
      } else {
        sb.append(this.attributeType);
      }
      first = false;
    }
    if (isSetIsMany()) {
      if (!first) sb.append(", ");
      sb.append("isMany:");
      sb.append(this.isMany);
      first = false;
    }
    if (isSetIsOrdered()) {
      if (!first) sb.append(", ");
      sb.append("isOrdered:");
      sb.append(this.isOrdered);
      first = false;
    }
    if (isSetIsUnique()) {
      if (!first) sb.append(", ");
      sb.append("isUnique:");
      sb.append(this.isUnique);
      first = false;
    }
    if (isSetDerivationLanguage()) {
      if (!first) sb.append(", ");
      sb.append("derivationLanguage:");
      if (this.derivationLanguage == null) {
        sb.append("null");
      } else {
        sb.append(this.derivationLanguage);
      }
      first = false;
    }
    if (isSetDerivationLogic()) {
      if (!first) sb.append(", ");
      sb.append("derivationLogic:");
      if (this.derivationLogic == null) {
        sb.append("null");
      } else {
        sb.append(this.derivationLogic);
      }
      first = false;
    }
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws org.apache.thrift.TException {
    // check for required fields
    if (metamodelUri == null) {
      throw new org.apache.thrift.protocol.TProtocolException("Required field 'metamodelUri' was not present! Struct: " + toString());
    }
    if (typeName == null) {
      throw new org.apache.thrift.protocol.TProtocolException("Required field 'typeName' was not present! Struct: " + toString());
    }
    if (attributeName == null) {
      throw new org.apache.thrift.protocol.TProtocolException("Required field 'attributeName' was not present! Struct: " + toString());
    }
    // check for sub-struct validity
  }

  private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
    try {
      write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, java.lang.ClassNotFoundException {
    try {
      // it doesn't seem like you should have to do this, but java serialization is wacky, and doesn't call the default constructor.
      __isset_bitfield = 0;
      read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private static class DerivedAttributeSpecStandardSchemeFactory implements org.apache.thrift.scheme.SchemeFactory {
    public DerivedAttributeSpecStandardScheme getScheme() {
      return new DerivedAttributeSpecStandardScheme();
    }
  }

  private static class DerivedAttributeSpecStandardScheme extends org.apache.thrift.scheme.StandardScheme<DerivedAttributeSpec> {

    public void read(org.apache.thrift.protocol.TProtocol iprot, DerivedAttributeSpec struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TField schemeField;
      iprot.readStructBegin();
      while (true)
      {
        schemeField = iprot.readFieldBegin();
        if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
          break;
        }
        switch (schemeField.id) {
          case 1: // METAMODEL_URI
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.metamodelUri = iprot.readString();
              struct.setMetamodelUriIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 2: // TYPE_NAME
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.typeName = iprot.readString();
              struct.setTypeNameIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 3: // ATTRIBUTE_NAME
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.attributeName = iprot.readString();
              struct.setAttributeNameIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 4: // ATTRIBUTE_TYPE
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.attributeType = iprot.readString();
              struct.setAttributeTypeIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 5: // IS_MANY
            if (schemeField.type == org.apache.thrift.protocol.TType.BOOL) {
              struct.isMany = iprot.readBool();
              struct.setIsManyIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 6: // IS_ORDERED
            if (schemeField.type == org.apache.thrift.protocol.TType.BOOL) {
              struct.isOrdered = iprot.readBool();
              struct.setIsOrderedIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 7: // IS_UNIQUE
            if (schemeField.type == org.apache.thrift.protocol.TType.BOOL) {
              struct.isUnique = iprot.readBool();
              struct.setIsUniqueIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 8: // DERIVATION_LANGUAGE
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.derivationLanguage = iprot.readString();
              struct.setDerivationLanguageIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 9: // DERIVATION_LOGIC
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.derivationLogic = iprot.readString();
              struct.setDerivationLogicIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          default:
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      struct.validate();
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot, DerivedAttributeSpec struct) throws org.apache.thrift.TException {
      struct.validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (struct.metamodelUri != null) {
        oprot.writeFieldBegin(METAMODEL_URI_FIELD_DESC);
        oprot.writeString(struct.metamodelUri);
        oprot.writeFieldEnd();
      }
      if (struct.typeName != null) {
        oprot.writeFieldBegin(TYPE_NAME_FIELD_DESC);
        oprot.writeString(struct.typeName);
        oprot.writeFieldEnd();
      }
      if (struct.attributeName != null) {
        oprot.writeFieldBegin(ATTRIBUTE_NAME_FIELD_DESC);
        oprot.writeString(struct.attributeName);
        oprot.writeFieldEnd();
      }
      if (struct.attributeType != null) {
        if (struct.isSetAttributeType()) {
          oprot.writeFieldBegin(ATTRIBUTE_TYPE_FIELD_DESC);
          oprot.writeString(struct.attributeType);
          oprot.writeFieldEnd();
        }
      }
      if (struct.isSetIsMany()) {
        oprot.writeFieldBegin(IS_MANY_FIELD_DESC);
        oprot.writeBool(struct.isMany);
        oprot.writeFieldEnd();
      }
      if (struct.isSetIsOrdered()) {
        oprot.writeFieldBegin(IS_ORDERED_FIELD_DESC);
        oprot.writeBool(struct.isOrdered);
        oprot.writeFieldEnd();
      }
      if (struct.isSetIsUnique()) {
        oprot.writeFieldBegin(IS_UNIQUE_FIELD_DESC);
        oprot.writeBool(struct.isUnique);
        oprot.writeFieldEnd();
      }
      if (struct.derivationLanguage != null) {
        if (struct.isSetDerivationLanguage()) {
          oprot.writeFieldBegin(DERIVATION_LANGUAGE_FIELD_DESC);
          oprot.writeString(struct.derivationLanguage);
          oprot.writeFieldEnd();
        }
      }
      if (struct.derivationLogic != null) {
        if (struct.isSetDerivationLogic()) {
          oprot.writeFieldBegin(DERIVATION_LOGIC_FIELD_DESC);
          oprot.writeString(struct.derivationLogic);
          oprot.writeFieldEnd();
        }
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

  }

  private static class DerivedAttributeSpecTupleSchemeFactory implements org.apache.thrift.scheme.SchemeFactory {
    public DerivedAttributeSpecTupleScheme getScheme() {
      return new DerivedAttributeSpecTupleScheme();
    }
  }

  private static class DerivedAttributeSpecTupleScheme extends org.apache.thrift.scheme.TupleScheme<DerivedAttributeSpec> {

    @Override
    public void write(org.apache.thrift.protocol.TProtocol prot, DerivedAttributeSpec struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TTupleProtocol oprot = (org.apache.thrift.protocol.TTupleProtocol) prot;
      oprot.writeString(struct.metamodelUri);
      oprot.writeString(struct.typeName);
      oprot.writeString(struct.attributeName);
      java.util.BitSet optionals = new java.util.BitSet();
      if (struct.isSetAttributeType()) {
        optionals.set(0);
      }
      if (struct.isSetIsMany()) {
        optionals.set(1);
      }
      if (struct.isSetIsOrdered()) {
        optionals.set(2);
      }
      if (struct.isSetIsUnique()) {
        optionals.set(3);
      }
      if (struct.isSetDerivationLanguage()) {
        optionals.set(4);
      }
      if (struct.isSetDerivationLogic()) {
        optionals.set(5);
      }
      oprot.writeBitSet(optionals, 6);
      if (struct.isSetAttributeType()) {
        oprot.writeString(struct.attributeType);
      }
      if (struct.isSetIsMany()) {
        oprot.writeBool(struct.isMany);
      }
      if (struct.isSetIsOrdered()) {
        oprot.writeBool(struct.isOrdered);
      }
      if (struct.isSetIsUnique()) {
        oprot.writeBool(struct.isUnique);
      }
      if (struct.isSetDerivationLanguage()) {
        oprot.writeString(struct.derivationLanguage);
      }
      if (struct.isSetDerivationLogic()) {
        oprot.writeString(struct.derivationLogic);
      }
    }

    @Override
    public void read(org.apache.thrift.protocol.TProtocol prot, DerivedAttributeSpec struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TTupleProtocol iprot = (org.apache.thrift.protocol.TTupleProtocol) prot;
      struct.metamodelUri = iprot.readString();
      struct.setMetamodelUriIsSet(true);
      struct.typeName = iprot.readString();
      struct.setTypeNameIsSet(true);
      struct.attributeName = iprot.readString();
      struct.setAttributeNameIsSet(true);
      java.util.BitSet incoming = iprot.readBitSet(6);
      if (incoming.get(0)) {
        struct.attributeType = iprot.readString();
        struct.setAttributeTypeIsSet(true);
      }
      if (incoming.get(1)) {
        struct.isMany = iprot.readBool();
        struct.setIsManyIsSet(true);
      }
      if (incoming.get(2)) {
        struct.isOrdered = iprot.readBool();
        struct.setIsOrderedIsSet(true);
      }
      if (incoming.get(3)) {
        struct.isUnique = iprot.readBool();
        struct.setIsUniqueIsSet(true);
      }
      if (incoming.get(4)) {
        struct.derivationLanguage = iprot.readString();
        struct.setDerivationLanguageIsSet(true);
      }
      if (incoming.get(5)) {
        struct.derivationLogic = iprot.readString();
        struct.setDerivationLogicIsSet(true);
      }
    }
  }

  private static <S extends org.apache.thrift.scheme.IScheme> S scheme(org.apache.thrift.protocol.TProtocol proto) {
    return (org.apache.thrift.scheme.StandardScheme.class.equals(proto.getScheme()) ? STANDARD_SCHEME_FACTORY : TUPLE_SCHEME_FACTORY).getScheme();
  }
}

